/* Tabela BOLETRECEBER: Boleto a Receber */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela BOLETRECEBER */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Boleto a Receber,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_FIN_BOLETREC
AFTER DELETE OR INSERT OR UPDATE
ON BOLETRECEBER FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_CDFILLOGOPER VARCHAR2(4);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_CDFILLOGOPER := '';
   IF DELETING THEN
      V_TIPO   := '3';
      V_DESC   := 'Venc '      || TO_CHAR(:OLD.DTVENBOLREC, 'DD/MM/YYYY')   ||
                  ' VrLiq '    || TO_CHAR(:OLD.VRFINALBREC)                 ||
                  ' Status '   || :OLD.IDSTATBREC                           ||
                  ' ContCC '   || :OLD.CDREDUCONT                           ||
                  ' TpBx '     || :OLD.CDTPBAIXAREC                         ||
                  ' Empr '     || :OLD.CDEMPRESA                            ||
                  ' Parc '     || :OLD.NRPARCBOLREC                         ||
                  ' VrOrig '   || TO_CHAR(:OLD.VRBOLREC)                    ||
                  ' CdCart '   || :OLD.CDCARTCOBBOL                         ||
                  ' TpCart '   || :OLD.IDCARTCOBREC                         ||
                  ' DtLiq '    || TO_CHAR(:OLD.DTLIQBOLREC, 'DD/MM/YYYY')   ||
                  ' SitCNAB '  || :OLD.IDSITUCNABR                          ||
                  ' FiliBx '   || :OLD.CDFILIBAIREC                         ||
                  ' NrBaixa '  || :OLD.NRBAIXAREC                           ||
                  ' ParcOrig ' || :OLD.NRORIGBOLREC                         ||
                  ' MovCred '  || :OLD.NRMOVICRED                           ||
                  ' NosNum '   || :OLD.CDNOSNUMREC;

      V_ITPESQ       := :OLD.CDFILIAL||:OLD.NRLANBOLREC|| '/' ||
                        :OLD.CDFILIBAIREC||:OLD.NRBAIXAREC|| '/' ||
                        :OLD.NRCNABRECREM;
      V_CDFILLOGOPER := :OLD.CDFILIAL;
   ELSE
      IF UPDATING THEN
         V_ITPESQ       := :OLD.CDFILIAL||:OLD.NRLANBOLREC|| '/' ||
                           :NEW.CDFILIBAIREC||:NEW.NRBAIXAREC|| '/' ||
                           :NEW.NRCNABRECREM;

         V_CDFILLOGOPER := :OLD.CDFILIAL;
         IF (:NEW.DTVENBOLREC  <> :OLD.DTVENBOLREC)  OR
            (:NEW.VRFINALBREC  <> :OLD.VRFINALBREC)  OR
            (:NEW.IDSTATBREC   <> :OLD.IDSTATBREC)   OR
            (:NEW.CDFILIAL     <> :OLD.CDFILIAL)     OR
            (:NEW.NRLANBOLREC  <> :OLD.NRLANBOLREC)  OR
            (:NEW.CDREDUCONT   <> :OLD.CDREDUCONT)   OR
            (:NEW.CDTPBAIXAREC <> :OLD.CDTPBAIXAREC) OR
            (:NEW.NRPARCBOLREC <> :OLD.NRPARCBOLREC) OR
            (:NEW.CDCARTCOBBOL <> :OLD.CDCARTCOBBOL) OR
            (:NEW.IDCARTCOBREC <> :OLD.IDCARTCOBREC) OR
            (:NEW.DTLIQBOLREC  <> :OLD.DTLIQBOLREC)  OR
            (:NEW.IDSITUCNABR  <> :OLD.IDSITUCNABR)  OR
            (:NEW.NRBAIXAREC   <> :OLD.NRBAIXAREC)   OR
            (:NEW.CDNOSNUMREC  <> :OLD.CDNOSNUMREC)  THEN
            V_TIPO   := '2';
         END IF;
      ELSE
         V_TIPO   := '1';
         V_ITPESQ       := :NEW.CDFILIAL||:NEW.NRLANBOLREC|| '/' ||
                           :NEW.CDFILIBAIREC||:NEW.NRBAIXAREC|| '/' ||
                           :NEW.NRCNABRECREM;
         V_CDFILLOGOPER := :NEW.CDFILIAL;
      END IF;

      V_DESC   := 'Venc '      || TO_CHAR(:NEW.DTVENBOLREC, 'DD/MM/YYYY')   ||
                  ' VrLiq '    || TO_CHAR(:NEW.VRFINALBREC)                 ||
                  ' Status '   || :NEW.IDSTATBREC                           ||
                  ' ContCC '   || :NEW.CDREDUCONT                           ||
                  ' TpBx '     || :NEW.CDTPBAIXAREC                         ||
                  ' Empr '     || :NEW.CDEMPRESA                            ||
                  ' Parc '     || :NEW.NRPARCBOLREC                         ||
                  ' VrOrig '   || TO_CHAR(:NEW.VRBOLREC)                    ||
                  ' CdCart '   || :NEW.CDCARTCOBBOL                         ||
                  ' TpCart '   || :NEW.IDCARTCOBREC                         ||
                  ' DtLiq '    || TO_CHAR(:NEW.DTLIQBOLREC, 'DD/MM/YYYY')   ||
                  ' SitCNAB '  || :NEW.IDSITUCNABR                          ||
                  ' FiliBx '   || :NEW.CDFILIBAIREC                         ||
                  ' NrBaixa '  || :NEW.NRBAIXAREC                           ||
                  ' ParcOrig ' || :NEW.NRORIGBOLREC                         ||
                  ' MovCred '  || :NEW.NRMOVICRED                           ||
                  ' NosNum '   || :NEW.CDNOSNUMREC;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                CDFILLOGOPER, DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('BOLETRECEBER', V_DTOPER, V_USUARIO,
                V_TIPO,         V_ITPESQ, V_DESC, V_CDFILLOGOPER,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIN_BOLETREC','5.20.000'); END;
/
