CREATE OR REPLACE FUNCTION CFOP_ITEM(
   P_CDIMPOSTO   IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA   IN NOTAFISCAL.CDEMPRESA%TYPE,
   P_CDINSCESTA  IN NOTAFISCAL.CDINSCESTA%TYPE,
   P_CDFILIAL    IN NOTAFISCAL.CDFILIAL%TYPE,
   P_CDCLIENTE   IN NOTAFISCAL.CDCLIENTE%TYPE,
   P_CDOPERACAO  IN NOTAFISCAL.CDTIPOOPER%TYPE,
   P_DTVALIDCFOP IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_CDARVPROD   IN PRODUTO.CDARVPROD%TYPE,
   P_PAISORIG    IN ENDECLIE.CDPAIS%TYPE,
   P_ESTAORIG    IN ENDECLIE.SGESTADO%TYPE,
   P_PAISDEST    IN ENDECLIE.CDPAIS%TYPE,
   P_ESTADEST    IN ENDECLIE.SGESTADO%TYPE) RETURN varchar2
AS
   V_CFOPITEM     VARCHAR2(14);
   V_CFOP1DIGT    VARCHAR2(1);
   V_CDARVPROD    VARCHAR2(20);
   V_CONTADOR     NUMBER;
   V_CDGRUPOFISC  CODFISCOPER.CDGRUPOFISC%TYPE;
   V_EXISTREGRA   VARCHAR2(1);
BEGIN
   V_EXISTREGRA := 'N';

   CONSULTA_GRUPOFISCAL('C', P_CDCLIENTE, P_CDFILIAL, 'S', P_CDOPERACAO, V_CDGRUPOFISC);

   IF P_PAISORIG = P_PAISDEST THEN
      IF P_ESTAORIG = P_ESTADEST THEN
         V_CFOP1DIGT := '5';
      ELSE
         V_CFOP1DIGT := '6';
      END IF;
   ELSE
      V_CFOP1DIGT := '7';
   END IF;

   /* Retorna o grupo fiscal para as operaes interestaduais */
   IF V_CFOP1DIGT = '6' THEN
      SELECT SUBSTR(DSPARGERFIS,3,3)
      INTO V_CDGRUPOFISC
      FROM PARAMGERAL;
   END IF;

   IF V_CDGRUPOFISC IS NULL THEN
      V_CDGRUPOFISC := V_CDGRUPOFISC;
   END IF;

   FOR C_REGRA IN (SELECT CDREGRAFISC, CDFISCOPER, IDDIFEALIQ, IDDIFALIQCUSPR, IDTIPOREGISTRO, IDMENSAGEM, CDCLASFISC, IDCFOPINTEREST, CDPRODUTO
                     FROM TABLE(CONSULTA_REGRA_FISCAL(P_CDIMPOSTO, P_CDEMPRESA, V_CDGRUPOFISC, 'S', P_CDOPERACAO, P_CDINSCESTA, P_CDARVPROD, P_DTVALIDCFOP,
                                                      P_PAISORIG, P_ESTAORIG, NULL, P_PAISDEST, P_ESTADEST, NULL, 0, 'N'))
                    WHERE CDFISCOPER IS NOT NULL) LOOP
      IF (C_REGRA.CDFISCOPER IS NOT NULL) THEN
          V_CFOPITEM := '  '||V_CFOP1DIGT||C_REGRA.CDFISCOPER;
      END IF;
      V_EXISTREGRA := 'S';
   END LOOP;

   IF V_CFOPITEM IS NULL THEN
      FOR C_REGRA IN (SELECT CDREGRAFISC, CDFISCOPER, IDDIFEALIQ, IDDIFALIQCUSPR, IDTIPOREGISTRO, IDMENSAGEM, CDCLASFISC, IDCFOPINTEREST, CDPRODUTO
                     FROM TABLE(CONSULTA_REGRA_FISCAL(P_CDIMPOSTO, P_CDEMPRESA, V_CDGRUPOFISC, 'S', P_CDOPERACAO, P_CDINSCESTA, P_CDARVPROD, P_DTVALIDCFOP,
                                                      P_PAISORIG, P_ESTAORIG, NULL, P_PAISDEST, P_ESTADEST, NULL, 0, 'S'))
                    WHERE CDFISCOPER IS NOT NULL) LOOP
         IF (C_REGRA.CDFISCOPER IS NOT NULL) THEN
             V_CFOPITEM := '  '||V_CFOP1DIGT||C_REGRA.CDFISCOPER;
         END IF;
         V_EXISTREGRA := 'S';
      END LOOP;
   END IF;

   IF V_EXISTREGRA = 'N' THEN
      IF V_CDGRUPOFISC IS NOT NULL THEN
         SELECT MAX(P.CDARVPROD), COUNT(*)
           INTO V_CDARVPROD, V_CONTADOR
           FROM CODFISCOPER C, PRODUTO P
          WHERE (IDENTSAICFOP = 'S')             AND
                (CDEMPRESA    = P_CDEMPRESA)     AND
                (CDTIPOOPER   = P_CDOPERACAO)    AND
                (CDINSCESTA   = P_CDINSCESTA)    AND
                (CDGRUPOFISC  = V_CDGRUPOFISC)   AND
                (C.CDPRODUTO  = P.CDPRODUTO(+))  AND
                (INSTR(P_CDARVPROD,NVL(RTRIM(P.CDARVPROD),P_CDARVPROD)) = 1);
      END IF;

      IF V_CONTADOR > 0 THEN
         IF NOT (V_CDARVPROD IS NULL) THEN
            SELECT MAX(CDFISCOPER)
              INTO V_CFOPITEM
              FROM CODFISCOPER C, PRODUTO P
             WHERE (C.IDENTSAICFOP = 'S')              AND
                   (C.CDEMPRESA    = P_CDEMPRESA)      AND
                   (C.CDTIPOOPER   = P_CDOPERACAO)     AND
                   (C.CDINSCESTA   = P_CDINSCESTA)     AND
                   (C.CDGRUPOFISC  = V_CDGRUPOFISC)    AND
                   (C.CDPRODUTO    = P.CDPRODUTO(+))   AND
                   (P.CDARVPROD    = V_CDARVPROD)      AND
                   (C.DTVALIDCFOP  = (SELECT MAX(DTVALIDCFOP)
                                        FROM CODFISCOPER C, PRODUTO P
                                       WHERE (C.IDENTSAICFOP = 'S')              AND
                                             (C.CDEMPRESA    = P_CDEMPRESA)      AND
                                             (C.CDTIPOOPER   = P_CDOPERACAO)     AND
                                             (C.CDINSCESTA   = P_CDINSCESTA)     AND
                                             (C.CDGRUPOFISC  = V_CDGRUPOFISC)    AND
                                             (C.CDPRODUTO    = P.CDPRODUTO(+))   AND
                                             (P.CDARVPROD    = V_CDARVPROD)      AND
                                             (C.DTVALIDCFOP <= P_DTVALIDCFOP)));
         ELSIF (V_CDARVPROD IS NULL) THEN
             SELECT MAX(CDFISCOPER)
               INTO V_CFOPITEM
               FROM CODFISCOPER C
              WHERE (C.IDENTSAICFOP = 'S')              AND
                    (C.CDEMPRESA    = P_CDEMPRESA)      AND
                    (C.CDTIPOOPER   = P_CDOPERACAO)     AND
                    (C.CDINSCESTA   = P_CDINSCESTA)     AND
                    (C.CDGRUPOFISC  = V_CDGRUPOFISC)    AND
                    (C.CDPRODUTO IS NULL)               AND
                    (C.DTVALIDCFOP  = (SELECT MAX(DTVALIDCFOP)
                                         FROM CODFISCOPER C
                                        WHERE (C.IDENTSAICFOP = 'S')              AND
                                              (C.CDEMPRESA    = P_CDEMPRESA)      AND
                                              (C.CDTIPOOPER   = P_CDOPERACAO)     AND
                                              (C.CDINSCESTA   = P_CDINSCESTA)     AND
                                              (C.CDGRUPOFISC  = V_CDGRUPOFISC)    AND
                                              (C.CDPRODUTO   IS NULL)             AND
                                              (C.DTVALIDCFOP <= P_DTVALIDCFOP)));
         END IF;
      ELSE
         SELECT MAX(P.CDARVPROD)
           INTO V_CDARVPROD
           FROM CODFISCOPER C, PRODUTO P
          WHERE (IDENTSAICFOP = 'S')             AND
                (CDEMPRESA    = P_CDEMPRESA)     AND
                (CDTIPOOPER   = P_CDOPERACAO)    AND
                (CDINSCESTA   = P_CDINSCESTA)    AND
                (CDGRUPOFISC IS NULL)            AND
                (C.CDPRODUTO  = P.CDPRODUTO(+))  AND
                (INSTR(P_CDARVPROD,NVL(RTRIM(P.CDARVPROD),P_CDARVPROD)) = 1);

         IF NOT (V_CDARVPROD IS NULL) THEN
            SELECT MAX(CDFISCOPER)
              INTO V_CFOPITEM
              FROM CODFISCOPER C, PRODUTO P
             WHERE (C.IDENTSAICFOP = 'S')              AND
                   (C.CDEMPRESA    = P_CDEMPRESA)      AND
                   (C.CDTIPOOPER   = P_CDOPERACAO)     AND
                   (C.CDINSCESTA   = P_CDINSCESTA)     AND
                   (C.CDGRUPOFISC IS NULL)             AND
                   (C.CDPRODUTO    = P.CDPRODUTO(+))   AND
                   (P.CDARVPROD    = V_CDARVPROD)      AND
                   (C.DTVALIDCFOP  = (SELECT MAX(DTVALIDCFOP)
                                        FROM CODFISCOPER C, PRODUTO P
                                       WHERE (C.IDENTSAICFOP = 'S')              AND
                                             (C.CDEMPRESA    = P_CDEMPRESA)      AND
                                             (C.CDTIPOOPER   = P_CDOPERACAO)     AND
                                             (C.CDINSCESTA   = P_CDINSCESTA)     AND
                                             (C.CDGRUPOFISC  IS NULL)            AND
                                             (C.CDPRODUTO    = P.CDPRODUTO(+))   AND
                                             (P.CDARVPROD    = V_CDARVPROD)      AND
                                             (C.DTVALIDCFOP <= P_DTVALIDCFOP)));

         ELSIF (V_CDARVPROD IS NULL) THEN
                SELECT MAX(CDFISCOPER)
                  INTO V_CFOPITEM
                  FROM CODFISCOPER C
                 WHERE (C.IDENTSAICFOP = 'S')              AND
                       (C.CDEMPRESA    = P_CDEMPRESA)      AND
                       (C.CDTIPOOPER   = P_CDOPERACAO)     AND
                       (C.CDINSCESTA   = P_CDINSCESTA)     AND
                       (C.CDGRUPOFISC IS NULL)             AND
                       (C.CDPRODUTO IS NULL)               AND
                       (C.DTVALIDCFOP  = (SELECT MAX(DTVALIDCFOP)
                                            FROM CODFISCOPER C
                                           WHERE (C.IDENTSAICFOP = 'S')              AND
                                                 (C.CDEMPRESA    = P_CDEMPRESA)      AND
                                                 (C.CDTIPOOPER   = P_CDOPERACAO)     AND
                                                 (C.CDINSCESTA   = P_CDINSCESTA)     AND
                                                 (C.CDGRUPOFISC  IS NULL)            AND
                                                 (C.CDPRODUTO    IS NULL)            AND
                                                 (C.DTVALIDCFOP <= P_DTVALIDCFOP)));
         END IF;
      END IF;
      IF (V_CFOPITEM IS NOT NULL) THEN
          V_CFOPITEM := '  '||V_CFOP1DIGT||V_CFOPITEM;
      END IF;
   END IF;
   RETURN (V_CFOPITEM);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CFOP_ITEM','6.05.000'); END;
/
